

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable offline 0


    variable Rmsg
    variable Wmsg

    variable ModuleName v1495
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable V1495RegisterMap {}
    lappend V1495RegisterMap {Firmware Firmware_Rev}
    lappend V1495RegisterMap {Scratch16 Scratch16}
    lappend V1495RegisterMap {Scratch32 Scratch32}

    variable DPPRegisterMap {}
    lappend DPPRegisterMap {Version Version}
    lappend DPPRegisterMap {"Accepted Trigger Scaler" AcceptedTriggers}
    lappend DPPRegisterMap {"NonAccepted Trigger Scaler" NonAcceptedTriggers}
    lappend DPPRegisterMap {"Control Register" Ctrl}
    lappend DPPRegisterMap {"Trigger Width" TriggerWidth}
    lappend DPPRegisterMap {"Trigger Channel" TriggerChannel}
    lappend DPPRegisterMap {"Trigger DeadTime" TriggerDeadTime}
    lappend DPPRegisterMap {"Single Shot Status" Arm}
    lappend DPPRegisterMap {"Diagnostic Delay" DiagDelay}
    lappend DPPRegisterMap {"Arm Limit" ArmLimit}

    lappend DPPRegisterMap {InputPort1 InputPort1}
    lappend DPPRegisterMap {InputPort2 InputPort2}
    lappend DPPRegisterMap {InputPort3 InputPort3}
    lappend DPPRegisterMap {OutputPort1 OutputPort1}
    lappend DPPRegisterMap {OutputPort2 OutputPort2}
    lappend DPPRegisterMap {OutputPort3 OutputPort3}
    lappend DPPRegisterMap {InputMask1 InputMask1}
    lappend DPPRegisterMap {InputMask2 InputMask2}
    lappend DPPRegisterMap {InputMask3 InputMask3}
    lappend DPPRegisterMap {UserValue1 UserValue1}
    lappend DPPRegisterMap {UserValue2 UserValue2}
    lappend DPPRegisterMap {UserValue3 UserValue3}
    lappend DPPRegisterMap {UserValue4 UserValue4}
    lappend DPPRegisterMap {IDD IDD}
    lappend DPPRegisterMap {IDE IDE}
    lappend DPPRegisterMap {IDF IDF}

    variable DPPSettings1 {}
    lappend DPPSettings1 {"Trigger Width" TriggerWidth}
    lappend DPPSettings1 {"Trigger Channel" TriggerChannel}
    lappend DPPSettings1 {"Trigger DeadTime" TriggerDeadTime}
    lappend DPPSettings1 {"Diagnostic Delay" DiagDelay}
    lappend DPPSettings1 {"Arm Limit" ArmLimit}
    lappend DPPSettings1 {"Single Shot Arm" Arm}

    variable DPPSettings2 {}
    lappend DPPSettings2 {InputMask1 InputMask1}
    lappend DPPSettings2 {InputMask2 InputMask2}
    lappend DPPSettings2 {InputMask3 InputMask3}

    variable DPPSettings3 {}
    lappend DPPSettings3 {UserValue1 UserValue1}
    lappend DPPSettings3 {UserValue2 UserValue2}
    lappend DPPSettings3 {UserValue3 UserValue3}
    lappend DPPSettings3 {UserValue4 UserValue4}

    variable DPPStatus1 {}
    lappend DPPStatus1 {"Accepted Trigger Scaler" AcceptedTriggers}
    lappend DPPStatus1 {"NonAccepted Trigger Scaler" NonAcceptedTriggers}

    variable DPPStatus2 {}
    lappend DPPStatus2 {InputPort1 InputPort1}
    lappend DPPStatus2 {InputPort2 InputPort2}
    lappend DPPStatus2 {InputPort3 InputPort3}

    variable DPPStatus3 {}
    lappend DPPStatus3 {OutputPort1 OutputPort1}
    lappend DPPStatus3 {OutputPort2 OutputPort2}
    lappend DPPStatus3 {OutputPort3 OutputPort3}

    variable DPPStatus4 {}
    lappend DPPStatus4 {IDD IDD}
    lappend DPPStatus4 {IDE IDE}
    lappend DPPStatus4 {IDF IDF}

    variable Config 0
    variable Config.B0 0
    variable Config.B2 0
    variable Config.B3 0
    variable Config.B4 0
    variable Config.B7 0
    variable Config.B8 0
    variable Config.B9 0

    variable SaveRestoreMenu {Ctrl TriggerWidth TriggerChannel TriggerDeadTime InputMask1 InputMask2 InputMask3}



     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc show_variables {} {
        variable ModuleIndex
        variable ModuleMenu
        variable alladcs
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
             InsertLog "ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
             InsertLog "Firmware Version=[ReadRegister Version]"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {
       variable Config
       variable Config.B0
       variable Config.B2
       variable Config.B3
       variable Config.B4
       variable Config.B7
       variable Config.B8
       variable Config.B9

       set Config [ReadRegister Ctrl]

       set Config.B0 [expr $Config & 3]
       set Config.B2 [expr ($Config >> 2) & 1]
       set Config.B3 [expr ($Config >> 3) & 1]
       set Config.B4 [expr ($Config >> 4) & 1]
       set Config.B7 [expr ($Config >> 7) & 1]
       set Config.B8 [expr ($Config >> 8) & 1]
       set Config.B9 [expr ($Config >> 9) & 1]

   }


    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex
        variable SaveRestoreMenu

       set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           DBSetValue Scratch16   [ReadRegister Scratch16]
           DBSetValue Scratch32   [ReadRegister Scratch32]

	foreach item $SaveRestoreMenu {
	    DBSetValue $item  [ReadRegister $item]
	}

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

   proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable SaveRestoreMenu

        set SAV1 $ModuleIndex

        set ModuleIndex $which

        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

       foreach item $SaveRestoreMenu {

	   WriteRegister $item [DBGetValue $item]
       }

        set ModuleIndex $SAV1
    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   SETTING     {WriteRegister [lindex $w 1] [lindex $w 2]}
                   SYSTEM      {
                       switch [lindex $w 1] {
                           FirmwareUpdate {Alert "Start firmware update from VME Control page"}
                           default {WriteRegister [lindex $w 1] 1}
                       }
                   }

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

